Package org.apache.sling.api.resource

# Interface ValueMap

All Superinterfaces:
  `Map<String,Object>`

All Known Subinterfaces:
  `ModifiableValueMap`, `PersistableValueMap`

All Known Implementing Classes:
  `CompositeValueMap`, `DeepReadModifiableValueMapDecorator`, `DeepReadValueMapDecorator`, `ModifiableValueMapDecorator`, `ValueMapDecorator`

@ConsumerType public interface ValueMap extends Map<String,Object>
The `ValueMap` is an easy way to access properties of a resource. With resources you can use `Resource.getValueMap()` to obtain the value map of a resource. The various getter methods can be used to get the properties of the resource.

In addition a value map returned by a resource supports getting of deep values, like get("content/title") which is equivalent to call getChild("content") on the resource, get the value map of that resource and call get("title") - but without requiring to do all the checks. Only the following methods support deep reads: `Map.get(Object)`, `get(String, Class)`, `get(String, Object)` and `Map.containsKey(Object)`.

A `ValueMap` should be immutable.

All methods may throw any `RuntimeException` if the underlying property cannot be read for some reason (e.g. if the underlying storage is corrupt).

## Nested Class Summary

## Nested classes/interfaces inherited from interface java.util.Map

`Map.Entry<K extends Object,V extends Object>`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ValueMap`
`EMPTY`
Empty immutable value map.

## Method Summary

Modifier and Type
Method
Description
`default <T> T`
`get(@NotNull String name, @NotNull Class<T> type)`
Get a named property and convert it into the given type.
`default <T> T`
`get(@NotNull String name, T defaultValue)`
Get a named property and convert it into the given type.

### Methods inherited from interface java.util.Map

`clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

## Field Details

### EMPTY

static final ValueMap EMPTY
Empty immutable value map.

## Method Details

### get

@Nullable default <T> T get(@NotNull @NotNull String name, @NotNull @NotNull Class<T> type)
Get a named property and convert it into the given type. This method does not support conversion into a primitive type or an array of a primitive type. It should return `null` in this case.

Type Parameters:
  `T` - The class of the type
Parameters:
  `name` - The name of the property
  `type` - The class of the type
Returns:
  Return named value converted to type T or `null` if non existing or can't be converted.
Throws:
  `RuntimeException` - if the underlying property cannot be accessed

### get

@NotNull default <T> T get(@NotNull @NotNull String name, @NotNull T defaultValue)
Get a named property and convert it into the given type. This method does not support conversion into a primitive type or an array of a primitive type. It should return the default value in this case.
Implementation hint: In the past it was allowed to call this with a 2nd parameter being `null`. Therefore all implementations should internally call `Map.get(Object)` when the 2nd parameter has value `null`.

Type Parameters:
  `T` - The expected type
Parameters:
  `name` - The name of the property
  `defaultValue` - The default value to use if the named property does not exist or cannot be converted to the requested type. The default value is also used to define the type to convert the value to. Must not be `null`. If you want to return `null` by default rather rely on `get(String, Class)`.
Returns:
  Return named value converted to type T or the default value if non existing or can't be converted.
Throws:
  `RuntimeException` - if the underlying property cannot be accessed